/* PositionedWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from PositionedWindow.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/window.h>
#include <glib.h>
#include "pantheon-desktop-shell-server-protocol.h"
#include <stdlib.h>
#include <string.h>
#include <mtk/mtk.h>
#include <meta/display.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW (greeter_compositor_positioned_window_get_type ())
#define GREETER_COMPOSITOR_POSITIONED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindow))
#define GREETER_COMPOSITOR_POSITIONED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindowClass))
#define GREETER_COMPOSITOR_IS_POSITIONED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW))
#define GREETER_COMPOSITOR_IS_POSITIONED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW))
#define GREETER_COMPOSITOR_POSITIONED_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindowClass))

typedef struct _GreeterCompositorPositionedWindow GreeterCompositorPositionedWindow;
typedef struct _GreeterCompositorPositionedWindowClass GreeterCompositorPositionedWindowClass;
typedef struct _GreeterCompositorPositionedWindowPrivate GreeterCompositorPositionedWindowPrivate;
typedef enum  {
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_TOP,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_BOTTOM,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_CENTER,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_FULLSCREEN
} GreeterCompositorPositionedWindowPosition;

#define GREETER_COMPOSITOR_POSITIONED_WINDOW_TYPE_POSITION (greeter_compositor_positioned_window_position_get_type ())
enum  {
	GREETER_COMPOSITOR_POSITIONED_WINDOW_0_PROPERTY,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY,
	GREETER_COMPOSITOR_POSITIONED_WINDOW_NUM_PROPERTIES
};
static GParamSpec* greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GreeterCompositorPositionedWindow {
	GObject parent_instance;
	GreeterCompositorPositionedWindowPrivate * priv;
};

struct _GreeterCompositorPositionedWindowClass {
	GObjectClass parent_class;
};

struct _GreeterCompositorPositionedWindowPrivate {
	MetaWindow* _window;
	GreeterCompositorPositionedWindowPosition _position;
	GVariant* _position_data;
	gulong position_changed_id;
};

static gint GreeterCompositorPositionedWindow_private_offset;
static gpointer greeter_compositor_positioned_window_parent_class = NULL;

VALA_EXTERN GType greeter_compositor_positioned_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorPositionedWindow, g_object_unref)
VALA_EXTERN GType greeter_compositor_positioned_window_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GreeterCompositorPositionedWindowPosition greeter_compositor_positioned_window_position_from_anchor (enum io_elementary_pantheon_panel_v1_anchor anchor);
static const char* _pantheon_desktop_anchor_to_string (enum io_elementary_pantheon_panel_v1_anchor value);
VALA_EXTERN GreeterCompositorPositionedWindow* greeter_compositor_positioned_window_new (MetaWindow* window,
                                                                             GreeterCompositorPositionedWindowPosition position,
                                                                             GVariant* position_data);
VALA_EXTERN GreeterCompositorPositionedWindow* greeter_compositor_positioned_window_construct (GType object_type,
                                                                                   MetaWindow* window,
                                                                                   GreeterCompositorPositionedWindowPosition position,
                                                                                   GVariant* position_data);
static void greeter_compositor_positioned_window_position_window (GreeterCompositorPositionedWindow* self);
VALA_EXTERN MetaWindow* greeter_compositor_positioned_window_get_window (GreeterCompositorPositionedWindow* self);
VALA_EXTERN GreeterCompositorPositionedWindowPosition greeter_compositor_positioned_window_get_position (GreeterCompositorPositionedWindow* self);
static void greeter_compositor_positioned_window_set_window (GreeterCompositorPositionedWindow* self,
                                                      MetaWindow* value);
VALA_EXTERN void greeter_compositor_positioned_window_set_position (GreeterCompositorPositionedWindow* self,
                                                        GreeterCompositorPositionedWindowPosition value);
VALA_EXTERN GVariant* greeter_compositor_positioned_window_get_position_data (GreeterCompositorPositionedWindow* self);
VALA_EXTERN void greeter_compositor_positioned_window_set_position_data (GreeterCompositorPositionedWindow* self,
                                                             GVariant* value);
static GObject * greeter_compositor_positioned_window_constructor (GType type,
                                                            guint n_construct_properties,
                                                            GObjectConstructParam * construct_properties);
static void _greeter_compositor_positioned_window_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                                     gpointer self);
static void _greeter_compositor_positioned_window_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                                         gpointer self);
static void _greeter_compositor_positioned_window_position_window_meta_window_shown (MetaWindow* _sender,
                                                                              gpointer self);
static void _greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                                  gpointer self);
static void _greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                           gpointer self);
static void _greeter_compositor_positioned_window_position_window_g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void greeter_compositor_positioned_window_finalize (GObject * obj);
static GType greeter_compositor_positioned_window_get_type_once (void);
static void _vala_greeter_compositor_positioned_window_get_property (GObject * object,
                                                              guint property_id,
                                                              GValue * value,
                                                              GParamSpec * pspec);
static void _vala_greeter_compositor_positioned_window_set_property (GObject * object,
                                                              guint property_id,
                                                              const GValue * value,
                                                              GParamSpec * pspec);

static inline gpointer
greeter_compositor_positioned_window_get_instance_private (GreeterCompositorPositionedWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterCompositorPositionedWindow_private_offset);
}

static const char*
_pantheon_desktop_anchor_to_string (enum io_elementary_pantheon_panel_v1_anchor value)
{
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
	switch (value) {
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_TOP:
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_TOP";
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_BOTTOM:
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_BOTTOM";
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_LEFT:
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_LEFT";
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_RIGHT:
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_RIGHT";
#line 166 "PositionedWindow.c"
	}
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
	return NULL;
#line 170 "PositionedWindow.c"
}

GreeterCompositorPositionedWindowPosition
greeter_compositor_positioned_window_position_from_anchor (enum io_elementary_pantheon_panel_v1_anchor anchor)
{
	GreeterCompositorPositionedWindowPosition result;
#line 16 "../compositor/ShellClients/PositionedWindow.vala"
	if (anchor > 1) {
#line 179 "PositionedWindow.c"
		const gchar* _tmp0_;
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		_tmp0_ = _pantheon_desktop_anchor_to_string (anchor);
#line 17 "../compositor/ShellClients/PositionedWindow.vala"
		g_warning ("PositionedWindow.vala:17: Position %s not supported yet", _tmp0_);
#line 18 "../compositor/ShellClients/PositionedWindow.vala"
		result = GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_CENTER;
#line 18 "../compositor/ShellClients/PositionedWindow.vala"
		return result;
#line 189 "PositionedWindow.c"
	}
#line 21 "../compositor/ShellClients/PositionedWindow.vala"
	result = (GreeterCompositorPositionedWindowPosition) anchor;
#line 21 "../compositor/ShellClients/PositionedWindow.vala"
	return result;
#line 195 "PositionedWindow.c"
}

static GType
greeter_compositor_positioned_window_position_get_type_once (void)
{
	static const GEnumValue values[] = {{GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_TOP, "GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_TOP", "top"}, {GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_BOTTOM, "GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_BOTTOM", "bottom"}, {GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_CENTER, "GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_CENTER", "center"}, {GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_FULLSCREEN, "GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_FULLSCREEN", "fullscreen"}, {0, NULL, NULL}};
	GType greeter_compositor_positioned_window_position_type_id;
	greeter_compositor_positioned_window_position_type_id = g_enum_register_static ("GreeterCompositorPositionedWindowPosition", values);
	return greeter_compositor_positioned_window_position_type_id;
}

GType
greeter_compositor_positioned_window_position_get_type (void)
{
	static volatile gsize greeter_compositor_positioned_window_position_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_positioned_window_position_type_id__once)) {
		GType greeter_compositor_positioned_window_position_type_id;
		greeter_compositor_positioned_window_position_type_id = greeter_compositor_positioned_window_position_get_type_once ();
		g_once_init_leave (&greeter_compositor_positioned_window_position_type_id__once, greeter_compositor_positioned_window_position_type_id);
	}
	return greeter_compositor_positioned_window_position_type_id__once;
}

GreeterCompositorPositionedWindow*
greeter_compositor_positioned_window_construct (GType object_type,
                                                MetaWindow* window,
                                                GreeterCompositorPositionedWindowPosition position,
                                                GVariant* position_data)
{
	GreeterCompositorPositionedWindow * self = NULL;
#line 35 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 36 "../compositor/ShellClients/PositionedWindow.vala"
	self = (GreeterCompositorPositionedWindow*) g_object_new (object_type, "window", window, "position", position, "position-data", position_data, NULL);
#line 35 "../compositor/ShellClients/PositionedWindow.vala"
	return self;
#line 232 "PositionedWindow.c"
}

GreeterCompositorPositionedWindow*
greeter_compositor_positioned_window_new (MetaWindow* window,
                                          GreeterCompositorPositionedWindowPosition position,
                                          GVariant* position_data)
{
#line 35 "../compositor/ShellClients/PositionedWindow.vala"
	return greeter_compositor_positioned_window_construct (GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, window, position, position_data);
#line 242 "PositionedWindow.c"
}

static void
greeter_compositor_positioned_window_position_window (GreeterCompositorPositionedWindow* self)
{
	gint x = 0;
	gint y = 0;
	MtkRectangle window_rect = {0};
	MetaWindow* _tmp0_;
	MtkRectangle _tmp1_ = {0};
	gint width = 0;
	MtkRectangle _tmp2_;
	gint height = 0;
	MtkRectangle _tmp3_;
	MetaDisplay* display = NULL;
	MetaWindow* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaDisplay* _tmp6_;
	GreeterCompositorPositionedWindowPosition _tmp7_;
	MetaWindow* _tmp40_;
	MetaWindow* _tmp41_;
	MetaWindow* _tmp42_;
#line 54 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_if_fail (self != NULL);
#line 55 "../compositor/ShellClients/PositionedWindow.vala"
	x = 0;
#line 55 "../compositor/ShellClients/PositionedWindow.vala"
	y = 0;
#line 56 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp0_ = self->priv->_window;
#line 56 "../compositor/ShellClients/PositionedWindow.vala"
	meta_window_get_frame_rect (_tmp0_, &_tmp1_);
#line 56 "../compositor/ShellClients/PositionedWindow.vala"
	window_rect = _tmp1_;
#line 57 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp2_ = window_rect;
#line 57 "../compositor/ShellClients/PositionedWindow.vala"
	width = _tmp2_.width;
#line 57 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp3_ = window_rect;
#line 57 "../compositor/ShellClients/PositionedWindow.vala"
	height = _tmp3_.height;
#line 58 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp4_ = self->priv->_window;
#line 58 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp5_ = meta_window_get_display (_tmp4_);
#line 58 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp6_ = _tmp5_;
#line 58 "../compositor/ShellClients/PositionedWindow.vala"
	display = _tmp6_;
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp7_ = self->priv->_position;
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
	switch (_tmp7_) {
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_CENTER:
#line 299 "PositionedWindow.c"
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp8_;
			MetaDisplay* _tmp9_;
			MtkRectangle _tmp10_ = {0};
			MtkRectangle _tmp11_;
			MtkRectangle _tmp12_;
			MtkRectangle _tmp13_;
			MtkRectangle _tmp14_;
			MtkRectangle _tmp15_;
			MtkRectangle _tmp16_;
#line 62 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp8_ = display;
#line 62 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp9_ = display;
#line 62 "../compositor/ShellClients/PositionedWindow.vala"
			meta_display_get_monitor_geometry (_tmp8_, meta_display_get_primary_monitor (_tmp9_), &_tmp10_);
#line 62 "../compositor/ShellClients/PositionedWindow.vala"
			monitor_geom = _tmp10_;
#line 63 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp11_ = monitor_geom;
#line 63 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp12_ = monitor_geom;
#line 63 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp13_ = window_rect;
#line 63 "../compositor/ShellClients/PositionedWindow.vala"
			x = _tmp11_.x + ((_tmp12_.width - _tmp13_.width) / 2);
#line 64 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp14_ = monitor_geom;
#line 64 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp15_ = monitor_geom;
#line 64 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp16_ = window_rect;
#line 64 "../compositor/ShellClients/PositionedWindow.vala"
			y = _tmp14_.y + ((_tmp15_.height - _tmp16_.height) / 2);
#line 65 "../compositor/ShellClients/PositionedWindow.vala"
			break;
#line 337 "PositionedWindow.c"
		}
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_TOP:
#line 341 "PositionedWindow.c"
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp17_;
			MetaDisplay* _tmp18_;
			MtkRectangle _tmp19_ = {0};
			MtkRectangle _tmp20_;
			MtkRectangle _tmp21_;
			MtkRectangle _tmp22_;
			MtkRectangle _tmp23_;
#line 68 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp17_ = display;
#line 68 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp18_ = display;
#line 68 "../compositor/ShellClients/PositionedWindow.vala"
			meta_display_get_monitor_geometry (_tmp17_, meta_display_get_primary_monitor (_tmp18_), &_tmp19_);
#line 68 "../compositor/ShellClients/PositionedWindow.vala"
			monitor_geom = _tmp19_;
#line 69 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp20_ = monitor_geom;
#line 69 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp21_ = monitor_geom;
#line 69 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp22_ = window_rect;
#line 69 "../compositor/ShellClients/PositionedWindow.vala"
			x = _tmp20_.x + ((_tmp21_.width - _tmp22_.width) / 2);
#line 70 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp23_ = monitor_geom;
#line 70 "../compositor/ShellClients/PositionedWindow.vala"
			y = _tmp23_.y;
#line 71 "../compositor/ShellClients/PositionedWindow.vala"
			break;
#line 373 "PositionedWindow.c"
		}
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_BOTTOM:
#line 377 "PositionedWindow.c"
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp24_;
			MetaDisplay* _tmp25_;
			MtkRectangle _tmp26_ = {0};
			MtkRectangle _tmp27_;
			MtkRectangle _tmp28_;
			MtkRectangle _tmp29_;
			MtkRectangle _tmp30_;
			MtkRectangle _tmp31_;
			MtkRectangle _tmp32_;
#line 74 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp24_ = display;
#line 74 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp25_ = display;
#line 74 "../compositor/ShellClients/PositionedWindow.vala"
			meta_display_get_monitor_geometry (_tmp24_, meta_display_get_primary_monitor (_tmp25_), &_tmp26_);
#line 74 "../compositor/ShellClients/PositionedWindow.vala"
			monitor_geom = _tmp26_;
#line 75 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp27_ = monitor_geom;
#line 75 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp28_ = monitor_geom;
#line 75 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp29_ = window_rect;
#line 75 "../compositor/ShellClients/PositionedWindow.vala"
			x = _tmp27_.x + ((_tmp28_.width - _tmp29_.width) / 2);
#line 76 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp30_ = monitor_geom;
#line 76 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp31_ = monitor_geom;
#line 76 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp32_ = window_rect;
#line 76 "../compositor/ShellClients/PositionedWindow.vala"
			y = (_tmp30_.y + _tmp31_.height) - _tmp32_.height;
#line 77 "../compositor/ShellClients/PositionedWindow.vala"
			break;
#line 415 "PositionedWindow.c"
		}
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_FULLSCREEN:
#line 419 "PositionedWindow.c"
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp33_;
			MetaDisplay* _tmp34_;
			MtkRectangle _tmp35_ = {0};
			MtkRectangle _tmp36_;
			MtkRectangle _tmp37_;
			MtkRectangle _tmp38_;
			MtkRectangle _tmp39_;
#line 80 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp33_ = display;
#line 80 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp34_ = display;
#line 80 "../compositor/ShellClients/PositionedWindow.vala"
			meta_display_get_monitor_geometry (_tmp33_, meta_display_get_primary_monitor (_tmp34_), &_tmp35_);
#line 80 "../compositor/ShellClients/PositionedWindow.vala"
			monitor_geom = _tmp35_;
#line 81 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp36_ = monitor_geom;
#line 81 "../compositor/ShellClients/PositionedWindow.vala"
			x = _tmp36_.x;
#line 82 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp37_ = monitor_geom;
#line 82 "../compositor/ShellClients/PositionedWindow.vala"
			y = _tmp37_.y;
#line 83 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp38_ = monitor_geom;
#line 83 "../compositor/ShellClients/PositionedWindow.vala"
			width = _tmp38_.width;
#line 84 "../compositor/ShellClients/PositionedWindow.vala"
			_tmp39_ = monitor_geom;
#line 84 "../compositor/ShellClients/PositionedWindow.vala"
			height = _tmp39_.height;
#line 85 "../compositor/ShellClients/PositionedWindow.vala"
			break;
#line 455 "PositionedWindow.c"
		}
		default:
#line 60 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 460 "PositionedWindow.c"
	}
#line 88 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp40_ = self->priv->_window;
#line 88 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_handler_block (_tmp40_, self->priv->position_changed_id);
#line 89 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp41_ = self->priv->_window;
#line 89 "../compositor/ShellClients/PositionedWindow.vala"
	meta_window_move_resize_frame (_tmp41_, FALSE, x, y, width, height);
#line 90 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp42_ = self->priv->_window;
#line 90 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_handler_unblock (_tmp42_, self->priv->position_changed_id);
#line 474 "PositionedWindow.c"
}

MetaWindow*
greeter_compositor_positioned_window_get_window (GreeterCompositorPositionedWindow* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp0_ = self->priv->_window;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	result = _tmp0_;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	return result;
#line 490 "PositionedWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 498 "PositionedWindow.c"
}

static void
greeter_compositor_positioned_window_set_window (GreeterCompositorPositionedWindow* self,
                                                 MetaWindow* value)
{
	MetaWindow* old_value;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_if_fail (self != NULL);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	old_value = greeter_compositor_positioned_window_get_window (self);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	if (old_value != value) {
#line 512 "PositionedWindow.c"
		MetaWindow* _tmp0_;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
		_g_object_unref0 (self->priv->_window);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
		self->priv->_window = _tmp0_;
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY]);
#line 522 "PositionedWindow.c"
	}
}

GreeterCompositorPositionedWindowPosition
greeter_compositor_positioned_window_get_position (GreeterCompositorPositionedWindow* self)
{
	GreeterCompositorPositionedWindowPosition result;
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	result = self->priv->_position;
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	return result;
#line 536 "PositionedWindow.c"
}

void
greeter_compositor_positioned_window_set_position (GreeterCompositorPositionedWindow* self,
                                                   GreeterCompositorPositionedWindowPosition value)
{
	GreeterCompositorPositionedWindowPosition old_value;
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	old_value = greeter_compositor_positioned_window_get_position (self);
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
	if (old_value != value) {
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
		self->priv->_position = value;
#line 30 "../compositor/ShellClients/PositionedWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY]);
#line 554 "PositionedWindow.c"
	}
}

GVariant*
greeter_compositor_positioned_window_get_position_data (GreeterCompositorPositionedWindow* self)
{
	GVariant* result;
	GVariant* _tmp0_;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp0_ = self->priv->_position_data;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	result = _tmp0_;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	return result;
#line 571 "PositionedWindow.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	return self ? g_variant_ref (self) : NULL;
#line 579 "PositionedWindow.c"
}

void
greeter_compositor_positioned_window_set_position_data (GreeterCompositorPositionedWindow* self,
                                                        GVariant* value)
{
	GVariant* old_value;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	g_return_if_fail (self != NULL);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	old_value = greeter_compositor_positioned_window_get_position_data (self);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	if (old_value != value) {
#line 593 "PositionedWindow.c"
		GVariant* _tmp0_;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
		_tmp0_ = _g_variant_ref0 (value);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
		_g_variant_unref0 (self->priv->_position_data);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
		self->priv->_position_data = _tmp0_;
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY]);
#line 603 "PositionedWindow.c"
	}
}

static void
_greeter_compositor_positioned_window_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                                gpointer self)
{
#line 42 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 613 "PositionedWindow.c"
}

static void
_greeter_compositor_positioned_window_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                                    gpointer self)
{
#line 43 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 622 "PositionedWindow.c"
}

static void
_greeter_compositor_positioned_window_position_window_meta_window_shown (MetaWindow* _sender,
                                                                         gpointer self)
{
#line 44 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 631 "PositionedWindow.c"
}

static void
_greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                             gpointer self)
{
#line 47 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 640 "PositionedWindow.c"
}

static void
_greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                                      gpointer self)
{
#line 48 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 649 "PositionedWindow.c"
}

static void
_greeter_compositor_positioned_window_position_window_g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 50 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_position_window ((GreeterCompositorPositionedWindow*) self);
#line 659 "PositionedWindow.c"
}

static GObject *
greeter_compositor_positioned_window_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterCompositorPositionedWindow * self;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gulong _tmp3_;
	MetaWindow* _tmp4_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaWindow* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaDisplay* _tmp7_;
	MetaContext* _tmp8_;
	MetaBackend* _tmp9_;
	MetaMonitorManager* _tmp10_;
	MetaMonitorManager* _tmp11_;
	MetaMonitorManager* _tmp12_;
#line 39 "../compositor/ShellClients/PositionedWindow.vala"
	parent_class = G_OBJECT_CLASS (greeter_compositor_positioned_window_parent_class);
#line 39 "../compositor/ShellClients/PositionedWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../compositor/ShellClients/PositionedWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindow);
#line 40 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp0_ = self->priv->_window;
#line 40 "../compositor/ShellClients/PositionedWindow.vala"
	meta_window_stick (_tmp0_);
#line 42 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp1_ = self->priv->_window;
#line 42 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object (_tmp1_, "size-changed", (GCallback) _greeter_compositor_positioned_window_position_window_meta_window_size_changed, self, 0);
#line 43 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp2_ = self->priv->_window;
#line 43 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp3_ = g_signal_connect_object (_tmp2_, "position-changed", (GCallback) _greeter_compositor_positioned_window_position_window_meta_window_position_changed, self, 0);
#line 43 "../compositor/ShellClients/PositionedWindow.vala"
	self->priv->position_changed_id = _tmp3_;
#line 44 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp4_ = self->priv->_window;
#line 44 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object (_tmp4_, "shown", (GCallback) _greeter_compositor_positioned_window_position_window_meta_window_shown, self, 0);
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp5_ = self->priv->_window;
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp6_ = meta_window_get_display (_tmp5_);
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp7_ = _tmp6_;
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp8_ = meta_display_get_context (_tmp7_);
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp9_ = meta_context_get_backend (_tmp8_);
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp10_ = meta_backend_get_monitor_manager (_tmp9_);
#line 46 "../compositor/ShellClients/PositionedWindow.vala"
	monitor_manager = _tmp10_;
#line 47 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp11_ = monitor_manager;
#line 47 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object (_tmp11_, "monitors-changed", (GCallback) _greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed, self, 0);
#line 48 "../compositor/ShellClients/PositionedWindow.vala"
	_tmp12_ = monitor_manager;
#line 48 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object (_tmp12_, "monitors-changed-internal", (GCallback) _greeter_compositor_positioned_window_position_window_meta_monitor_manager_monitors_changed_internal, self, 0);
#line 50 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object ((GObject*) self, "notify::position", (GCallback) _greeter_compositor_positioned_window_position_window_g_object_notify, self, 0);
#line 51 "../compositor/ShellClients/PositionedWindow.vala"
	g_signal_connect_object ((GObject*) self, "notify::position-data", (GCallback) _greeter_compositor_positioned_window_position_window_g_object_notify, self, 0);
#line 39 "../compositor/ShellClients/PositionedWindow.vala"
	return obj;
#line 736 "PositionedWindow.c"
}

static void
greeter_compositor_positioned_window_class_init (GreeterCompositorPositionedWindowClass * klass,
                                                 gpointer klass_data)
{
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	greeter_compositor_positioned_window_parent_class = g_type_class_peek_parent (klass);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	g_type_class_adjust_private_offset (klass, &GreeterCompositorPositionedWindow_private_offset);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_greeter_compositor_positioned_window_get_property;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_greeter_compositor_positioned_window_set_property;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = greeter_compositor_positioned_window_constructor;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = greeter_compositor_positioned_window_finalize;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 757 "PositionedWindow.c"
	/**
	     * This may only be set after the window was shown.
	     * The initial position should only be given in the constructor.
	     */
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", GREETER_COMPOSITOR_POSITIONED_WINDOW_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY, greeter_compositor_positioned_window_properties[GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY] = g_param_spec_variant ("position-data", "position-data", "position-data", G_VARIANT_TYPE_ANY, NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 766 "PositionedWindow.c"
}

static void
greeter_compositor_positioned_window_instance_init (GreeterCompositorPositionedWindow * self,
                                                    gpointer klass)
{
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	self->priv = greeter_compositor_positioned_window_get_instance_private (self);
#line 775 "PositionedWindow.c"
}

static void
greeter_compositor_positioned_window_finalize (GObject * obj)
{
	GreeterCompositorPositionedWindow * self;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindow);
#line 25 "../compositor/ShellClients/PositionedWindow.vala"
	_g_object_unref0 (self->priv->_window);
#line 31 "../compositor/ShellClients/PositionedWindow.vala"
	_g_variant_unref0 (self->priv->_position_data);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	G_OBJECT_CLASS (greeter_compositor_positioned_window_parent_class)->finalize (obj);
#line 790 "PositionedWindow.c"
}

static GType
greeter_compositor_positioned_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterCompositorPositionedWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_compositor_positioned_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterCompositorPositionedWindow), 0, (GInstanceInitFunc) greeter_compositor_positioned_window_instance_init, NULL };
	GType greeter_compositor_positioned_window_type_id;
	greeter_compositor_positioned_window_type_id = g_type_register_static (G_TYPE_OBJECT, "GreeterCompositorPositionedWindow", &g_define_type_info, 0);
	GreeterCompositorPositionedWindow_private_offset = g_type_add_instance_private (greeter_compositor_positioned_window_type_id, sizeof (GreeterCompositorPositionedWindowPrivate));
	return greeter_compositor_positioned_window_type_id;
}

GType
greeter_compositor_positioned_window_get_type (void)
{
	static volatile gsize greeter_compositor_positioned_window_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_positioned_window_type_id__once)) {
		GType greeter_compositor_positioned_window_type_id;
		greeter_compositor_positioned_window_type_id = greeter_compositor_positioned_window_get_type_once ();
		g_once_init_leave (&greeter_compositor_positioned_window_type_id__once, greeter_compositor_positioned_window_type_id);
	}
	return greeter_compositor_positioned_window_type_id__once;
}

static void
_vala_greeter_compositor_positioned_window_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec)
{
	GreeterCompositorPositionedWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindow);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	switch (property_id) {
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		g_value_set_object (value, greeter_compositor_positioned_window_get_window (self));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		g_value_set_enum (value, greeter_compositor_positioned_window_get_position (self));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		g_value_set_variant (value, greeter_compositor_positioned_window_get_position_data (self));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 843 "PositionedWindow.c"
		default:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 849 "PositionedWindow.c"
	}
}

static void
_vala_greeter_compositor_positioned_window_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec)
{
	GreeterCompositorPositionedWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GREETER_COMPOSITOR_TYPE_POSITIONED_WINDOW, GreeterCompositorPositionedWindow);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
	switch (property_id) {
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_WINDOW_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		greeter_compositor_positioned_window_set_window (self, g_value_get_object (value));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		greeter_compositor_positioned_window_set_position (self, g_value_get_enum (value));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		case GREETER_COMPOSITOR_POSITIONED_WINDOW_POSITION_DATA_PROPERTY:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		greeter_compositor_positioned_window_set_position_data (self, g_value_get_variant (value));
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 881 "PositionedWindow.c"
		default:
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../compositor/ShellClients/PositionedWindow.vala"
		break;
#line 887 "PositionedWindow.c"
	}
}

